
#pragma warning (disable : 4786)
#pragma warning (disable : 4996)
#pragma warning (disable : 4267)

#include <stdio.h>
#include <string>
#include <vector>

#include "dirent.h"

std::vector <std::string> vecDir;

std::vector <std::string> vecPic;
std::vector <std::string> vecSnd;

int main(int argc, char**argv)
{
  DIR *dir = 0;
  struct dirent *ent;
  std::string dirname;
  std::string str;
  int i, num;

  if (argc < 2) { vecDir.push_back("data"); }
  for (i=1;i<argc;i+=1)
  { vecDir.push_back(argv[i]); }

  dirname = "data";

  num = vecDir.size();
  for (i=0;i<num;i+=1)
  {
   dirname = vecDir[i];
   dir = opendir (dirname.c_str());
   while ((ent = readdir (dir)) != NULL)
		{
    
			printf ("%s\n", ent->d_name);

      str = ent->d_name;
      if (str.find(".png") != -1)   { vecPic.push_back(str.substr(0,str.size()-4)); }
      else if (str.find(".mp3") != -1) { vecSnd.push_back(str.substr(0,str.size()-4)); }

    }//wend
   closedir (dir);
  }//nexti

  FILE * f;
  f = fopen("xData.as", "wt");
  fprintf(f, "package  { \n ");
  fprintf(f, "import flash.utils.Dictionary;  \n ");
  fprintf(f, "import flash.media.Sound;  \n ");   
  fprintf(f, " public class xData {  \n \n");

  
  fprintf(f, "\n");
  num = vecPic.size();
  for (i=0;i<num;i+=1)
  {
    str = vecPic[i];
    fprintf(f, "   [Embed(source = \"data/%s.png\")] private static var embed_%s:Class; \n", str.c_str(), str.c_str() );
  }//nexti
   
  fprintf(f, "\n");
  num = vecSnd.size();
  for (i=0;i<num;i+=1)
  {
    str = vecSnd[i];
    fprintf(f, "   [Embed(source = \"data/%s.mp3\")] private static var embed_%s:Class; \n", str.c_str(), str.c_str() );
  }//nexti

  fprintf(f, "\n");

  fprintf(f, "  public static function loadPic(dict:Dictionary):void { \n");
    num = vecPic.size();
    for (i=0;i<num;i+=1)
    {
      str = vecPic[i];
      fprintf(f, "   dict[\"%s\"] = (new embed_%s).bitmapData; \n", str.c_str(), str.c_str() );
    }//nexti

  fprintf(f, "  }//loadpic \n\n");

  fprintf(f, "  public static function loadSnd(dict:Dictionary):void { \n");
   num = vecSnd.size();
    for (i=0;i<num;i+=1)
    {
      str = vecSnd[i];
      fprintf(f, "   dict[\"%s\"] = (new embed_%s) as Sound; \n", str.c_str(), str.c_str() );
    }//nexti
  fprintf(f, "  }//loadsnd \n\n");


  fprintf(f, "\n }//classend \n");
  fprintf(f, "}//package \n");
  fclose(f);


 return 0;
}//main
