package 
{
  import flash.display.BitmapData;
  import flash.display.Graphics;
  import flash.display.Sprite;
  import flash.events.Event;
  import flash.events.KeyboardEvent;
  import flash.events.MouseEvent;
  import flash.geom.ColorTransform;
  import flash.geom.Matrix;
  import flash.geom.Point;
  import flash.geom.Rectangle;
  import flash.net.URLLoader;
  import flash.net.URLLoaderDataFormat;
  import flash.net.URLRequest;
  import flash.net.URLRequestMethod;
  import flash.net.URLVariables;
  import flash.sampler.NewObjectSample;
  import flash.ui.Keyboard;
  import flash.utils.Dictionary;



	[Frame(factoryClass="Preloader")]
	public class Main extends xGame 
	{

		public function Main():void 
		{
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init);
		}
  
    

    [Embed(source = "minifont8.png")]  private static var embedFontPic8:Class;
    [Embed(source = "minifont8.xfnt", mimeType = "application/octet-stream")]
    private static var embedFont8:Class;
   
		private function init(e:Event = null):void 
		{
			removeEventListener(Event.ADDED_TO_STAGE, init);
			// entry point
      
      mySound.bMute = Preloader.bStartMute;
      toggleSound(mySound.bMute);
      toggleMusic(mySound.bMute);
      
      //if (bDebug) { sendData(null);  } 

      
      stage.quality = "LOW";
      
      xData.loadPic(dictPic);
      xData.loadSnd(mySound.dictSnd);
 
      myAdvFont = new xAdvFont();
      myAdvFont.loadFont(embedFont8, embedFontPic8);
      
      
          netHisc = new xNetScore();
          netHisc.init();
           netHisc.getHisc(); 




          locHisc = new xScores();
          locHisc.init();
          if (bDebug)
          {
            var r:int;
            var i:int;
            r =  Math.random() * 3000;
            i = locHisc.getScorePlace(r);
            locHisc.submitScore("randman"+int(Math.random()*9), r, i);
            //locHisc.getScore(i);
          }//endif

      xActor.game = this;
   
      
      newGame();
      resetGame();

      inGame = false;
      gameState = GS_MENU;
      
      stage.addEventListener(MouseEvent.MOUSE_DOWN, onMdown);
      stage.addEventListener(MouseEvent.MOUSE_UP, onMup);
      stage.addEventListener(KeyboardEvent.KEY_DOWN, onKdown);
      stage.addEventListener(KeyboardEvent.KEY_UP, onKup);
      stage.addEventListener(Event.ENTER_FRAME, onEnter);   
		}//init

      
    public var dictPic:Dictionary = new Dictionary();
    public function getData(wname:String):BitmapData
    { return dictPic[wname]; }

    
    public var gameState:int = 0;
    
    public var GS_GAME:int = 0;
    public var GS_MENU:int = 1;
    public var GS_SHOWSCORE:int = 2;
    public var GS_SUBMIT:int = 3;
    
    
    //public var bDebug:Boolean = true;
    public var bDebug:Boolean = false;
    
    public var locHisc:xScores = null;
    public var netHisc:xNetScore = null;
    public var curLetter:int = 0;
    public var subName:Vector.<int> = Vector.<int>([65, 65, 65]);
    public var subScore:int = 1500;
//    public var subName:String = "AAA";
    public var holdUp:int = 0;
    public var holdDown:int = 0;
    public var holdLeft:int = 0;
    public var holdRight:int = 0;
    public var holdEnter:int = 0;
    public var holdEsc:int = 0;
    public var inGame:Boolean = false;
    
  
    public var myAdvFont:xAdvFont;    
    public var canMat:Matrix = new Matrix(2, 0, 0, 2, 0, 0);

    public var numLife:int = 0;
    public var manLeft:int = 0;
    public var score:int = 0;
    public var startWave:int = 0;
    public var wave:int = 0;
    public var lastStart:int = 0;
    public var allTime:int = 0;
    
    public var shiftx:Number = 0;
    public var camx:Number = 0;
 
    public var numLeft:int = 0;
    public var mapDone:int = 0;
    public var nextMake:int = 0;
    
    public var respawn:int = 0;
    
    public var playerx:Number = 0;
    public var playery:Number = 0;
    


    public function newGame():void
    {
      score = 0;
      wave = 0; 
      fade = 1;
      allTime = 0;
      numLife = 2;
      manLeft = 8;
      inGame = true;
     
      setRandomSeed(Math.random() * 256);
    }//newgame
    
    public function resetGame():void
    {
      
      resetPart();      
      genBackdrop();
      
      vecAct = new Vector.<xActor>(0, false);
      vecBull = new Vector.<xActor>(0, false);
      
      playerx = 0;
      playery = 0;
      nextMake = 0;
      respawn = 0;
      mapDone = 0;
      shiftx = 0;
      numLeft = 0;
      gt = 0;
      
      var a:xActor;
       a = new xPlayer();
        a.cx = 160; a.cy = 120;
        a.dmgTime = gt + 120;
       addAct(a);
      
       var i:int;
       
       /*
       for (i = 0; i < 3; i += 1)
       {
        a = new xBalloon();
        //a.cx = Math.random() * 320;
        a.cx = getRand2() * 1280;
        a.cy = Math.random() * 180;
        addAct(a);
         
       }
       */
       
       if (manLeft < 8 ) { manLeft += 1;  }
       
       for (i = 0; i < manLeft; i += 1)
       {
        a = new xPerson();
         a.cx = getRand2() * 1280;
         a.cy = 220;
         addAct(a);
       }
       
       /*
       a = new xStealer();
        a.cx = 320;
        a.cy = 0;
       addAct(a);
       */
       

       if (wave == 0) { numLeft = 3; }
       else if (wave == 1) { numLeft = 8; }
       else if (wave == 2) { numLeft = 13; }
       else {  numLeft =  15 + wave; }
      
       nextMake = gt + 10; // gt + 150 + getRand() * 50;
       
       
       //startmessage
       // "these clowns think its black friday
       //       and im having a sale"
       // 
       
    }//reset
    
    
      public var menuOpt:int = 0 ;

        
      public var bonus:int = 0;
      public var bonusMan:int = 0;
      
      public var fade:Number = 0;
      public var fadeCt:ColorTransform = new ColorTransform();
  
      public var holdDeb:int = 0;
      
    public function onEnter(e:Event):void
    {  
      if (isKeyDown(Keyboard.UP) || isKeyDown(Keyboard.W)) { holdUp += 1; }
      else { holdUp = 0; }
      if (isKeyDown(Keyboard.DOWN) || isKeyDown(Keyboard.S)) { holdDown += 1; }
      else { holdDown = 0; }
      if (isKeyDown(Keyboard.LEFT) || isKeyDown(Keyboard.A)) { holdLeft += 1; }
      else { holdLeft = 0; }
      if (isKeyDown(Keyboard.RIGHT) || isKeyDown(Keyboard.D)) { holdRight += 1; }
      else { holdRight = 0; }
      if (isKeyDown(Keyboard.ENTER)||isKeyDown(Keyboard.SPACE)) { holdEnter += 1; }
      else { holdEnter = 0; }
      if (isKeyDown(Keyboard.ESCAPE) || isKeyDown(Keyboard.P)  ) { holdEsc += 1; }
      else { holdEsc = 0; }
     
      
      if (isKeyDown(Keyboard.O)) { holdDeb += 1; }
      else { holdDeb = 0; }
      if (bDebug == false) { holdDeb = 0; }
      if (holdDeb == 1) { netHisc.getHisc();  }
      
      
      mySound.setPos(160, 120, 0);
      mySound.setNorm(0, 1, 0);
      
     var ms:Number;

      resetBtn();
      mx = stage.mouseX; my = stage.mouseY;
      if (mx < 0) { mx = 0; } if (my < 0) { my = 0; }
      if (mx > 640) { mx = 640; } if (my > 480) { my = 480; }
      wmx = mx; wmy = my;
   
      if (gameState == GS_GAME)
      {
        num = 1;

        if (bDebug && isKeyDown(Keyboard.U)) { num = 8; }
        
        for (i = 0; i < num; i += 1)
        {
           thinkVec(vecAct, gt);
           updateVec(vecAct);
           updateVec(vecBull);
           updatePart();
           
           shiftVec(vecAct);
           shiftVec(vecBull);
           shiftPart();
           
           camx += shiftx;
           shiftx = 0;
          
           
           gt += 1;
          keyTime += 1;
        }//nexti
          
          
          
          if (gt > 10 && (gt % 30 == 0) && mapDone <= 0)
          {
            var i:int; var num:int; var a:xActor;
            var numen:int; 
            numen = 0;
            num = vecAct.length;
            for (i = 0; i < num; i += 1)
            {
              a = vecAct[i];
              if (a.dead) { continue; }
              if (a.team == 3) { numen += 1; } 
            }//nexti
            if (numen <= 0 && numLeft <= 0)
            { mapDone += 1; }
          }//endif
          
          
          if (numLeft > 0 && nextMake < gt)
          {
            numLeft -= 1;
            k = 50 - wave; if (k < 5) { k = 5; }
            nextMake = gt + k + getRand() * 90 + 10;
            if (getRand() < 0.23) { nextMake = gt + 5; }
            makeThing();
          }//endif
          
          
          if (mapDone > 160) { fade += 0.05; if (fade >= 1) { fade = 1; } }
          else { fade-= 0.05; if ( fade <= 0) { fade = 0; } }
          
          if (mapDone > 0)
          {
            mapDone += 1;
            if (mapDone >= 180) { allTime+= gt; resetGame(); mapDone = 0; wave+= 1;   }  
          }//endif
          
          if (respawn > 0)
          { respawn += 1;
            if (respawn >= 60 && numLife > 0) {
                numLife-= 1;
                respawn = 0;
                a = new xPlayer;
                  a.cx = 160; a.cy = 120;
                  a.dmgTime = gt + 90;
                addAct(a);
              }//endif
                if (respawn >= 90 && numLife <= 0)
                {
                   //newGame(); resetGame(); 
                   inGame = false;
                   menuOpt = 0;
                   respawn = 0;
                   lastStart = startWave;
                    if (wave > startWave) { startWave = wave; }
                     if (score > 1000)
                     {
                         if (netHisc.hasHisc)
                         {
                          gameState = GS_SUBMIT;
                          subScore = score;
                          return;
                         }
                         else 
                           if (locHisc.getScorePlace(score) < 10)
                           {
                            gameState = GS_SUBMIT;
                            subScore = score;
                            return;
                           }//endif4                             
                     }//endif3
                    gameState = GS_SHOWSCORE;
                    return;
                }//endif2
                
          }//endif
           
          if ( bDebug && isKeyDown(Keyboard.K)) { respawn = 1; return; }
          if ( bDebug && isKeyDown(Keyboard.M)) { wave+= 1; resetGame(); return; }
          if ( bDebug && isKeyDown(Keyboard.N)) { wave+= 5; resetGame(); return; }
      }//endif //updategame
              
      graphics.clear();
      canvas.lock();
        canvas.fillRect(canvas.rect, 0x404040);
        fillRect(canvas, 0, 200, 320, 2, 0);
       // fillRect(canvas, 0, 200, 320, 1, 0xFFffFF);
          
        
    
        
      //if (gameState == GS_GAME)
    //  if (inGame)
      {
        
        drawImage(canvas, getData("moon"), 16, 16, true);
        
        drawFall(canvas, getData("clouds"), 0, 24, 320, 32, Number(gt)*0.1, 24);
        
       // drawImage(canvas,getData("hill"),        
       drawFall(canvas, getData("hill"), 0, 240 - 40 -64, 320, 64, camx * 0.1, 240-40-64 );
      drawImage(canvas, backDrop, 0, 0, true);
      
        
        var grnd:BitmapData; grnd = getData("ground");
        var u:Number; u = 0.5;
        var v:Number; v = 30;
        for (i = 0; i < 7; i += 1)
        {       
         drawFall(canvas, grnd, 0, 240 -8 - v, 320, grnd.height, camx * u, 0);

         if (i == 1)
         {
          drawFall(canvas, getData("vine"), 0, 240 - 40-21 , 320, 32, camx * 0.5, 240-40-21 );
         }//endif
         // drawImage(canvas, grnd, ((camx*u)%320), 240 - 4-v, true);
         //drawImage(canvas, grnd, ((camx*u)%320)+320, 240 - 4-v, true);
        // drawImage(canvas, grnd, ((camx*u) % 320) + 320 + 320, 240 - 4-v, true);
          u += 0.1; v -= 6;
        }
          
        renderShad(vecAct);
        renderShad(vecBull);
      
        renderVec(vecAct);
        renderVec(vecBull);
        renderPart();
        radarVec(vecAct);
        
        myAdvFont.writeStr(canvas, 16, 4, "Score: " + score);
        myAdvFont.writeStr(canvas, 16, 16, "Life: " + numLife);
        myAdvFont.writeStr(canvas, 320 - 80, 4, "Wave: " + wave);
     
      }//endif //rendergame
        
        
     
        
        if (fade > 0)
        { 
          var ft:Number;  ft = 1 -fade;          
          fadeCt.blueMultiplier = ft; fadeCt.redMultiplier = ft; fadeCt.greenMultiplier = ft;
          canvas.colorTransform(canvas.rect, fadeCt);
        }//endif
        
        //if (inGame && gameState != GS_GAME)
        if (gameState != GS_GAME || mapDone>0)
        {
          ft = 0.55;
          fadeCt.blueMultiplier = ft; fadeCt.redMultiplier = ft; fadeCt.greenMultiplier = ft;
          canvas.colorTransform(canvas.rect, fadeCt);          
        }//endif
        
           
        if (mapDone > 0 && gameState == GS_GAME)
        {
          myAdvFont.writeStr(canvas, 160, 120, "Wave Complete!" + (bDebug?mapDone:""), null, 1);  
          
          if (mapDone == 3) { bonusMan = 0; bonus = 0;  playSound("safeland", 1.0);  }
          
          if (mapDone % 5 == 0 && mapDone> 30 && bonusMan < manLeft)
          { bonusMan += 1; bonus += 250; score+= 250;  playSound("help", 1.0); }
          
          if (mapDone > 20)
          {
            myAdvFont.writeStr(canvas, 160, 140, "Left: " + bonusMan,null,1);
          }
          if (mapDone > 60)
          {
            myAdvFont.writeStr(canvas, 160, 140+16, "Lives: " + numLife,null,1);
          }
          
          if (mapDone == 120 && manLeft > 4) 
          { if ( numLife < 4) { numLife+= 1; playSound("rescue", 1.0); } else { score+= 1000; }  }
          
        }//endif
        
      
        if (bDebug && isKeyDown(Keyboard.B))
       {
        gameState = GS_SUBMIT;
        //gameState = GS_SHOWSCORE;
        //subName = "AAA";
        subScore = Math.random() * 5000 + 1000;
       }//endif
        
       if (gameState == GS_SHOWSCORE || gameState == GS_SUBMIT)
       {
          myAdvFont.writeStr(canvas, 160, 16,  "HOTSHOTS",null,1);
        var vecScore:Array;
        vecScore = locHisc.vecSave;
        if (netHisc.hasHisc) { vecScore = netHisc.vecSave; }
        for (i = 0; i < 10; i += 1)
        {
          myAdvFont.writeStr(canvas, 64+24, 32+i*16,  " "  + vecScore[(i*2)]);
          myAdvFont.writeStr(canvas, 160+24, 32+i*16, " " + vecScore[(i*2)+1]);
        }//nexti 
        if ((holdEnter == 1 || holdEsc == 1) && gameState == GS_SHOWSCORE)
        { gameState = GS_MENU; holdEnter = 3; holdEsc = 3; }
         if (netHisc.hasHisc && netHisc.refresh) {  /*trace("refresh");*/  myAdvFont.writeStr(canvas, 160, 10, "Refreshing.. ", null, 1, 0.5); }
       }//endif
       
       if (gameState == GS_SUBMIT)
       {
            drawSprite2(canvas, myAdvFont.getCharData(subName[0]), 80, 210, 0, false, false, 2, 2);
            drawSprite2(canvas, myAdvFont.getCharData(subName[1]), 80+24, 210, 0, false, false, 2, 2);
            drawSprite2(canvas, myAdvFont.getCharData(subName[2]), 80+48, 210, 0, false, false, 2, 2);
            drawSprite2(canvas, myAdvFont.getCharData(95), 80+24*curLetter, 210+11, 0, false, false, 2, 2);
                   
           var temp:String; temp = subScore.toString();
           num = temp.length;
           for (i = 0; i < num; i += 1)
           { 
            drawSprite2(canvas, myAdvFont.getCharData(temp.charCodeAt(i)), 180+18*i, 210, 0, false, false, 2, 2);         
           }
            
           myAdvFont.writeStr(canvas, 160, 230, "Use arrows to enter thine initials", null, 1, 0.5);

          //  myAdvFont.writeStr(canvas, 80, 220, String.fromCharCode(subName[0]), null, 0, 1);
           // myAdvFont.writeStr(canvas, 80+16, 220, String.fromCharCode(subName[1]), null, 0, 1);
           // myAdvFont.writeStr(canvas, 80+32, 220, String.fromCharCode(subName[2]), null, 0, 1);
          //  myAdvFont.writeStr(canvas, 80 + 16 * curLetter, 220 + 4, "_", null, 0, 1);
            if (holdLeft == 1) { curLetter -= 1; } if (curLetter < 0) { curLetter = 0; }
            if (holdRight == 1) { curLetter += 1; } if (curLetter > 2) { curLetter = 2; }
            var k:int;
            if (holdUp == 1 || holdDown == 1)
            {
                k = subName[curLetter];
                if (holdUp == 1) { k -= 1; }
                else { k += 1; }
                if (k < 65) { k = 90; }
                if (k > 90) { k = 65; }
                //trace("k", k);
                subName[curLetter] = k;
            }//endif
            if (holdEnter == 1)
            {
              holdEnter = 3;
              this.playSound("score", 1.0);
              gameState = GS_SHOWSCORE; 
              var tempName:String;
              tempName = String.fromCharCode(subName[0]) + String.fromCharCode(subName[1]) + String.fromCharCode(subName[2]);
              
           
                if (netHisc.hasHisc)
                {
                  netHisc.submitScore(tempName, subScore, allTime+gt, lastStart, wave);
                }
                else
                {
                 k = locHisc.getScorePlace(subScore);  
                 locHisc.submitScore(tempName, subScore, k);
                }//endif3
            }//endif2
        }//endif
        
        
          if (gameState == GS_GAME)
          { if (holdEsc == 1) { gameState = GS_MENU; holdEsc = 3; this.playSound("menu", 1.0); } }
        
          if (gameState == GS_MENU)
          {
            if (inGame == false)
            { drawImage(canvas, getData("gamelogo"), 0, 10, true); }
            else 
            {  myAdvFont.writeStr(canvas, 160, 80, "PAUSED", null, 1);   }
            
            
             myAdvFont.writeStr(canvas, 160, 120, inGame ? (menuOpt==0?"[Back to Game]":"Back to Game") : (menuOpt==0?"[New Game]":"New Game"), null, 1);  
             myAdvFont.writeStr(canvas, 160, 140, menuOpt==1?"[Scores]":"Scores", null, 1);  
             myAdvFont.writeStr(canvas, 160, 160, menuOpt==2?"[Sounds]":"Sounds", null, 1);  
             if (inGame) { myAdvFont.writeStr(canvas, 160, 180, menuOpt==3?"[End Game]":"End Game", null, 1); }
             if (menuOpt==2) {   myAdvFont.writeStr(canvas, 210, 160, mySound.bMute ? "- Off" : "- On" , null, 0);  }
             if (inGame == false && menuOpt == 0) 
             { 
               myAdvFont.writeStr(canvas, 210, 120, "- Wave: " + startWave, null, 0);
               myAdvFont.writeStr(canvas, 30, 230, "Use arrows to change starting wave", null, 0, 0.5);
             }//endif2

             if (holdEsc == 1 && inGame) { gameState = GS_GAME; holdEsc = 3; holdEnter = 3; }
             
            if (menuOpt == 0)
            {
             if (holdEnter == 1) { gameState = GS_GAME; if (inGame == false) { newGame(); wave = startWave; resetGame(); } holdEnter = 3; }
             if (holdDown == 1) { menuOpt = 1; holdDown = 3; }
             if (holdLeft == 1  || (holdLeft>6 && (holdLeft%2 == 0)) ) { startWave -= 1;  holdLeft = 3; }
             if (holdRight == 1 || (holdRight>6 && (holdRight%2 == 0)) ) { startWave += 1;  }
             if (startWave < 0) { startWave = 0; }
            }
            else if (menuOpt == 1)
            {
             if (holdEnter == 1) { gameState = GS_SHOWSCORE; holdEnter = 3; }
             if (holdUp == 1) { menuOpt = 0; holdUp = 3; }
             if (holdDown == 1) { menuOpt = 2; holdDown = 3; }
            } 
            else if (menuOpt == 2)
            {
             if (holdUp == 1) { menuOpt = 1; holdUp = 3; }
             if (holdDown == 1 && inGame) { menuOpt = 3; holdDown = 3; }
             if (holdEnter == 1) { holdEnter = 3; mySound.bMute = !mySound.bMute; toggleMusic(mySound.bMute); toggleSound(mySound.bMute);  }
            }
            else if (menuOpt == 3)
            {
             if (holdUp == 1) { menuOpt = 2; holdUp = 3; }
             if (holdEnter == 1) { respawn = 91; score += numLife * 100; numLife = -1; gameState = GS_GAME; holdEnter = 3; }              
            }//endif
            
            
          }//menu
      
        
      //  myAdvFont.writeStr(canvas, 16, 16, "" + gt);
      canvas.unlock();
        graphics.beginBitmapFill(canvas, canMat, false, false);
          graphics.drawRect(0, 0, 640, 480);
        graphics.endFill();        
      
      /*
      graphics.lineStyle(2, 0);
        ms = 8;
        graphics.moveTo(mx, my - ms);
        graphics.lineTo(mx, my + ms);
        graphics.moveTo(mx-ms, my);
        graphics.lineTo(mx+ms, my);

*/
    
    }//onenter
    
    
  public function radarVec(vec:Vector.<xActor>):void
  {
     var ax:int;
     ax = 160-50;
     drawRect(canvas, ax+ 160/16, 0, 1280 / 16, 240 / 16, 0x808080);
     drawRect(canvas, ax+ 160/16+480/16, 0, 320 / 16, 240 / 16, 0x808080);

     var i:int; var num:int; var a:xActor;   num = vec.length;
     for (i = 0; i < num; i += 1) { 
      a = vec[i]; if (a.dead) { continue; }
      if (a.specType == 900) { continue; }
      canvas.setPixel(ax+((640+a.cx) / 16)|0, (a.cy / 16)|0, a.rcol);
     // drawRect(canvas, a.cx - a.xrad, a.cy - a.yrad, a.xrad * 2, a.yrad * 2, 0xFFffFF);
    }//nexti                      
  }//radarvec
  
  public function renderShad(vec:Vector.<xActor>):void
  {
     var i:int; var num:int; var a:xActor;   num = vec.length;
     var shad:BitmapData;
     shad = getData("shad");
     for (i = 0; i < num; i += 1) { 
      a = vec[i]; if (a.dead) { continue; }
      if (a.specType == 900) { continue; }
        drawSprite(canvas, shad, a.cx|0, 230, true, false, false);  
      //a.render();
    }//nexti                      
  }//rendershad
 
      public var ctDmg:ColorTransform = new ColorTransform(1, 1, 1, 1, 128, 128, 128);
  
  public function renderVec(vec:Vector.<xActor>):void
  {
     var i:int; var num:int; var a:xActor;   num = vec.length;
     for (i = 0; i < num; i += 1) { 
      a = vec[i]; if (a.dead) { continue; }
        if (a.specType == 900) { 
            myAdvFont.writeStr(canvas, a.cx, a.cy, a.wstr, null, 1, a.hp);
          continue; 
        }//endif
        
      if (a.skin == null) { continue; }
     
      if (a.team == 1 && a.specType != 5 && a.dmgTime > gt &&  (((gt + a.id) & 4) == 0) ) { continue; }

      if (a.dmgTime > gt && (a.team != 1 || a.specType == 5))
      {
        drawSprite2(canvas, a.skin, a.cx | 0, a.cy | 0, 0, a.dir != 0, false, 1, 1, null, ctDmg);     
        continue;
      }
      
        drawSprite(canvas, a.skin, a.cx|0, a.cy|0, true, a.dir != 0, false);  
     
      if (bDebug && isKeyDown(Keyboard.T))
      { drawRect(canvas, a.cx - a.xrad, a.cy - a.yrad, a.xrad * 2, a.yrad * 2, 0xFFffFF); }

      a.render();
    }//nexti                      
  }//rendervec
  
  
  public function shiftVec(vec:Vector.<xActor>):void
  {
     var i:int; var num:int; var a:xActor;   num = vec.length;
     for (i = 0; i < num; i += 1) { 
      a = vec[i]; if (a.dead) { continue; }
      if (a.noshift) { continue; }
      a.cx += shiftx;
      if (a.cx < -640+160) { a.cx += 1280; }
      else if (a.cx > (640+160)) { a.cx -= 1280; }
    }//nexti                      
  }//rendervec
      
    
      
   public var vecAct:Vector.<xActor>;
   public function addAct(a:xActor):void    {  addActorx(a, vecAct); }  
 
   public var vecBull:Vector.<xActor>;
   public function addBull(a:xActor):void    {  addActorx(a, vecBull); }  
  
    public var dictAct:Dictionary = new Dictionary();   public var curId:int = 1;
    public function addActorx(a:xActor, vec:Vector.<xActor>):void // a.game = this;
    { a.id = curId; curId += 1;  vec.push(a);  dictAct[a.id] = a;    a.init();  }    
    public function getActor(id:int):xActor  { return dictAct[id]; }             

    public function updateVec(vec:Vector.<xActor>):void
    { var bRemDead:Boolean; bRemDead = false;
      var i:int; var num:int; var a:xActor;   num = vec.length;
      for (i = 0; i < num; i+=1) { a = vec[i]; if (a.dead) {  bRemDead = true; continue; }
       if (a.asleep) { continue; } a.update();  }//nexti      
      if (bRemDead == false) { return; }      
      var k:int;  num = vec.length;
      for (i = 0; i < num; i+=1) { a = vec[i]; if (a.dead == false) { continue; }
        for (k = i; k < num-1; k+=1){ vec[k] = vec[k + 1]; }
        i -= 1;   a.remove();   vec.pop(); num = vec.length;
        delete dictAct[a.id]; }//nexti
    }//update    
        
    public function thinkVec(vec:Vector.<xActor>, t:int):void
    { var i:int; var num:int; var a:xActor;   num = vec.length;
      for (i = 0; i < num; i+=1) { a = vec[i]; if (a.dead) { continue; }
       if ((a.id+t)%20 != 0) { continue; } a.think();  }//nexti            
    }//thinkvec       

      
    public var vecPart:Vector.<xPart>;
    public var itPart:int = 0;
    public function resetPart():void
    { vecPart = new Vector.<xPart>(256, false); 
      var i:int; var num:int;   
      num = vecPart.length;
      for (i = 0; i < num; i += 1) { vecPart[i] = new xPart(); }
      itPart = 0;
    }//resetpart
     
    public function shiftPart():void
    {
       var i:int; var num:int; var a:xPart; 
       num = vecPart.length;
       for (i = 0; i < num; i += 1) { 
        a = vecPart[i]; if (a.hp<=0) { continue; }
        if (a.noshift) { continue; }
        a.cx += shiftx;
        if (a.cx < -640+160) { a.cx += 1280; }
        else if (a.cx > (640+160)) { a.cx -= 1280; }
      }//nexti                      
    }//shiftpart
  
    public function addPart(ax:Number, ay:Number):xPart
    {
      var a:xPart;
      a = vecPart[itPart]; itPart += 1; if (itPart >= vecPart.length) { itPart = 0; }
      a.cx = ax; a.cy = ay;
      a.hp = 10;
      a.skin = null; a.col = 0x505050;
      a.vx = 0; a.vy = 0;
      a.noshift = false;
      return a;
    }//addpart
    
    public function updatePart():void
    {
     var i:int; var num:int; var a:xPart;
     num = vecPart.length;
     for (i = 0; i < num; i += 1)
     { a = vecPart[i]; 
       if (a.hp <= 0) { continue; }
       a.hp -= 1;
       a.cx += a.vx; a.cy += a.vy;
     }//nexti
    }//updatepart  
    
    public function renderPart():void
    {
     var i:int; var num:int; var a:xPart;
     num = vecPart.length;
     for (i = 0; i < num; i += 1)
     { a = vecPart[i]; 
       if (a.hp <= 0) { continue; }
       if (a.skin != null)
       {  continue; }
       canvas.setPixel(a.cx, a.cy, a.col);
     }//nexti
    }//updatepart  
    
 
    public var backDrop:BitmapData = new BitmapData(320, 240, true, 0);
     
    public function genBackdrop():void
    {
      var rc:Number;      var gc:Number;       var bc:Number;
      var rcw:Number;     var gcw:Number;      var bcw:Number;
      t = 0.35; u = 0.125;
      rc = Math.random()*t;      gc = Math.random()*t;      bc = Math.random()*t;
      rcw = Math.random()*u;     gcw = Math.random()*u;     bcw = Math.random()*u;
     
      var t:Number; var u:Number; var i:int;
      var kx:Number; var ky:Number; var kz:Number;
      var c:uint;
      u = 1 / 200; i = 0;
      for (t = 0; t < 1.0; t += u)
      {
        kx = rc + (rcw - rc) * t;
        ky = gc + (gcw - gc) * t;
        kz = bc + (bcw - bc) * t;
        c = 0;
        c |= (0xFF * kx) & 0xFF;
        c |= ((0xFF * ky) & 0xFF)<<8;
        c |= ((0xFF * kz) & 0xFF) << 16;
        c |= 0x88 << 24;
        fillRect(backDrop, 0, i, 320, 1, c);
        i += 1;
      }//nextt
      
    }//genbackdrop   
    

    public function getRandCol():uint
    {
      var r:uint;
      r = 0;
      r |= (0xFF * getRand()) & 0xFF;
      r |= ((0xFF * getRand()) & 0xFF)<<8;
      r |= ((0xFF * getRand()) & 0xFF)<<16;
      return r;
    } ///getrcol
    
    
    public function addScore(ax:Number, ay:Number, s:int):xActor
    {
      score += s;
      var a:xActor;
       a = new xTextObj();
       a.cx = ax; a.cy = ay;
       //a.reward = s;
       a.wstr = s.toString();
      addBull(a);      
      return a;
    }//addscore
      
    public function spriteBlast(ax:Number, ay:Number):void
    {
       var a:xActor;
       a = new xBlast();
        a.cx = ax; a.cy = ay;
       addBull(a);
    }//spriteblast  
    
    
    public function partBlast(ax:Number, ay:Number, pow:Number=2, num:int=64, col:int=-1):void
    {
      var i:int; var p:xPart;
      for (i = 0; i < num; i += 1)
      {
        p = addPart(ax, ay);
        p.cx += getRand2() * 8;
        p.cy += getRand2() * 8;
        p.vx += getRand2()*pow;
        p.vy += getRand2()*pow;
        p.hp = 30 + getRand() * 60;
        if (col != -1) { p.col = col; }
        else { p.col = getRandCol(); }
      }//nexti
      
    }//partblast
       
    
    /*
    //seems to work so far (but it will only get more tricky)
    
//http://stackoverflow.com/questions/6876588/sending-and-receiving-data-from-flash-as3-to-php
    public function sendData(event:MouseEvent):void
    {
      var urlreq:URLRequest = new URLRequest ("https://battlecavemanepisode1.000webhostapp.com/score.php");
      urlreq.method = URLRequestMethod.POST; 

      var urlvars:URLVariables = new URLVariables(); 
      urlvars.score = "3000";
      urlreq.data = urlvars;          

      var loader:URLLoader = new URLLoader (urlreq); 
      loader.addEventListener(Event.COMPLETE, completed); 
      //loader.dataFormat = URLLoaderDataFormat.VARIABLES; 
      loader.dataFormat = URLLoaderDataFormat.TEXT; 
      loader.load(urlreq); 
    }//senddata

    public function completed (event:Event):void {
    
      var data:String;
      data = event.target.data;
      trace("data ", data);
      var str:String;
      var i:int;
      i = data.indexOf("[[Start]]");
      trace("i", i);
      if (i == -1) { return; }
      str = data.substr(i+9);
      var vec:Array;
      vec = str.split(",", 20);
      trace("vec ", vec);
      //new url
      //var variables:URLVariables = new URLVariables( event.target.data );
      //trace("done: ",  variables);
    }//completed

    */

    
    public static var vecHitStr:Vector.<String> = Vector.<String>(["Oh the humanity!", 
    "Don't drink and fly!", "Ouch!", "Explosion!", "...", "KAMIKAZE!",
    "There goes another broom..",  "Noooo!", "Yeargh!",
    "Do not want",  "Nein!", "404 witch not found", "Aye!", "-1", ":(",
    "Random Text #19", "Headshot!", "Overshoes",
     "Packers and Movers"]);

    public function getHitStr():String
    {
      var i:int; i = vecHitStr.length * getRand();
      return vecHitStr[i];      
    }//hitstr
 
    
    
   public function makeThing():void
   {
     
     var a:xActor;
     var i:int;
     
      if (wave == 3)
      {
        
         a = new xSupes();
           a.cx = 1280 * getRand();
           a.cy = -30;
          addAct(a);
         a = new xSupes();
           a.cx = 1280 * getRand();
           a.cy = -30;
          addAct(a);
          return;
      }//endif 
     
     
      if (wave == 6)
      {
        for (i = 0; i < 3; i += 1)
        {
          a = new xElf();
           a.cx = getRand() < 0.5 ? -100 : 320 + 100;
           a.cy = 220;
           a.cx += getRand2() * 64;
           a.dir = a.cx < 160 ? 0 : 16;
           
          addAct(a);
        }
        return;
      }//endif
      
      
      
      if (wave == 9)
      {  
        a = new  xNaut();
         a.cx = getRand() < 0.5 ? -50 : 320 + 50;
         a.cy = -40;
        addAct(a);
        return;
      }//endif
      
      
      if (wave == 12 )
      {
        a = new xSkull();
         a.cx = getRand() < 0.5 ? -50 : 320 + 50;
         a.cy = -40;
        addAct(a);
        return;
      }//endif
      
     
       if (wave > 12 && getRand() < 0.25)
            {
                a = new xSkull();
                 a.cx = getRand() < 0.5 ? -50 : 320 + 50;
                 a.cy = -40;
                addAct(a);
            }
            else 
            if (wave > 9 && getRand() < 0.25)
            {
                a = new  xNaut();
                 a.cx = getRand() < 0.5 ? -50 : 320 + 50;
                 a.cy = -40;
                addAct(a);
            }
            else 
            if (wave >= 5 && getRand() < 0.25)
            {
                a = new xElf();
                 a.cx = getRand() < 0.5 ? -50 : 320 + 50;
                 a.cy = 220;
                 a.dir = a.cx < 160 ? 0 : 16;
                 //a.cx = 160;
                addAct(a);
            }
            else 
            if (wave >= 2 && getRand() < 0.25)
            {
                a = new xSupes();
                 a.cx = 1280 * getRand();
                 a.cy = -30;
                addAct(a);
            }//endif
            
            
            a = new xStealer();
             a.cx = 1280*getRand();
             a.cy = -32;
            addAct(a);  
     
     
     
   }//makething   
    
    
    
    
  }//classend
}

















